<?php

// QuickTalk 2.5 build:20100924

ob_start();

$bShowtoc = false;
if ( substr($oVIP->selfurl,0,7)=='qtf_adm' || substr($oVIP->selfurl,0,5)=='qtfm_' ) $bShowtoc=true;

echo QTF_HTML_DTD,'
<html xmlns="http://www.w3.org/1999/xhtml" dir="',QTF_HTML_DIR,'" xml:lang="',QTF_HTML_LANG,'">
<head>
<title>Administration</title>
<meta http-equiv="content-type" content="text/html; charset=',QTF_HTML_CHAR,'"/>
<meta name="description" content="QT QuickTalk forum"/>
<meta name="keywords" content="quicktalk,forum,faq,knowledge,qt-cute,OpenSource"/>
<meta name="author" content="qt-cute.org" />
<meta name="language" content="en,fr,nl"/>
<link rel="shortcut icon" href="admin/qtf_icon.ico"/>
<link rel="stylesheet" type="text/css" href="admin/qtf_main.css"/>
<script type="text/javascript">
<!--
function qtEdited(bEdited,str)
{
  if (bEdited) { if (!confirm(qtHtmldecode(str))) return false; }
  return true;
}
function qtHtmldecode(str)
{
  var ta=document.createElement("textarea");
  ta.innerHTML=str.replace(/</g,"&lt;").replace(/>/g,"&gt;");
  return ta.value;
}
-->
</script>
';

if ( !empty($strHeadScript) ) echo $strHeadScript;

echo '</head>
';

echo '
<body'.(isset($strBodyAddOnload) ? ' onload="'.$strBodyAddOnload.'"': '').(isset($strBodyAddOnunload) ? ' onunload="'.$strBodyAddOnunload.'"': '').'>
';

echo '
<!-- MENU/PAGE -->
<table style="width:900px" cellspacing="0" cellpadding="0">
<tr valign="top">
<td style="',($bShowtoc ? 'width:175px;' : 'width:1px;'),' vertical-align:top;">
';

if ( $bShowtoc )
{

echo '
<!-- TOC -->
<div class="menu">
<div class="banner"><img class="logo" id="toc_logo" src="admin/qtf_logo.gif" width="175" height="50" style="border-width:0" alt="QuickTalk" title="QuickTalk"/></div>
<div class="header">',strtoupper($L['Administration']),'</div>
';

if ( file_exists('bin/qtf_lang.php') )
{
  include('bin/qtf_lang.php');
  $strURI = QTargimplode(QTarradd(QTargexplode(),'lx'));
  $strLangMenu = '';
  foreach($arrLang as $strKey=>$arrDef)
  {
  $strLangMenu .= '<a href="'.$oVIP->selfurl.'?'.$strURI.'&amp;lx='.$strKey.'" title="'.$arrDef[1].'" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">'.$arrDef[0].'</a>&nbsp;';
  }
}
else
{
  $strLangMenu .= 'missing file:bin/qtf_lang.php';
}

echo '<p class="language">',$strLangMenu,'</p>
';

$str = 'return qtEdited(bEdited,\''.$L['E_editing'].'\');';
echo '<div class="group">
<p class="group">',$L['Info'],'</p>
<p class="item"><a href="qtf_adm_index.php" onclick="'.($oVIP->selfurl=='qtf_adm_index.php' ? 'return false;' : $str).'">',$L['Adm_status'],'</a></p>
<p class="item"><a href="qtf_adm_site.php" onclick="'.($oVIP->selfurl=='qtf_adm_site.php' ? 'return false;' : $str).'">',$L['Adm_general'],'</a></p>
</div>
<div class="group">
<p class="group">',$L['Adm_settings'],'</p>
<p class="item"><a href="qtf_adm_region.php" onclick="'.($oVIP->selfurl=='qtf_adm_region.php' ? 'return false;' : $str).'">',$L['Adm_region'],'</a></p>
<p class="item"><a href="qtf_adm_skin.php" onclick="'.($oVIP->selfurl=='qtf_adm_skin.php' ? 'return false;' : $str).'">',$L['Adm_layout'],'</a></p>
<p class="item"><a href="qtf_adm_secu.php" onclick="'.($oVIP->selfurl=='qtf_adm_secu.php' ? 'return false;' : $str).'">',$L['Adm_security'],'</a></p>
</div>
<div class="group">
<p class="group">',$L['Adm_content'],'</p>
<p class="item"><a href="qtf_adm_sections.php" onclick="'.($oVIP->selfurl=='qtf_adm_sections.php' ? 'return false;' : $str).'">',$L['Sections'],'</a></p>
<p class="item"><a href="qtf_adm_topic.php" onclick="'.($oVIP->selfurl=='qtf_adm_topic.php' ? 'return false;' : $str).'">',$L['Topics'],'</a></p>
<p class="item"><a href="qtf_adm_users.php" onclick="'.($oVIP->selfurl=='qtf_adm_users.php' ? 'return false;' : $str).'">',$L['Members'],'</a></p>
<p class="item"><a href="qtf_adm_tags.php" onclick="'.($oVIP->selfurl=='qtf_adm_tags.php' ? 'return false;' : $str).'">',$L['Tags'],'</a></p>
</div>
<div class="group">
<p class="group">',$L['Adm_modules'],'</p>
';

// search modules
$arrModules = GetParam(false,'param LIKE "module%"');
if ( count($arrModules)>0 )
{
  foreach($arrModules as $strKey=>$strValue)
  {
  $strKey = str_replace('module_','',$strKey);
  echo '<p class="item"><a href="qtfm_',$strKey,'_adm.php" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">',$strValue,'</a></p>',N;
  }
}
echo '<p class="item"><a href="qtf_adm_module.php?a=add" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">[',$L['Add'],']</a>&nbsp;&middot;&nbsp;<a class="menu" href="qtf_adm_module.php?a=rem" onclick="return warningedited(bEdited,\''.$L['E_editing'].'\');">[',$L['Remove'],']</a></p>
</div>
<div class="footer"><a href="qtf_index.php" target="_top" onclick="return qtEdited(bEdited,\''.$L['E_editing'].'\');">',$L['Exit'],'</a></div>
</div>
';
}

echo '
</td>
<td style="padding-left:10px; vertical-align:top;">

<!-- MAIN -->
';

HtmlBanner(2,'admin','qtf_logo.gif');

// Title (and help frame)

echo '<div style="width:300px; margin-bottom:20px"><h1>',$oVIP->selfname,'</h1>';
if ( isset($strPageversion) ) echo '<p class="small">',$strPageversion,'</p>';
if ( !empty($error) ) echo '<p id="infomessage" class="error">',$error,'</p>';
if ( empty($error) && !empty($warning) ) echo '<p id="warningmessage" class="warning">',$warning,'</p>';
if ( empty($error) && isset($strInfo) ) echo '<p id="infomessage" style="color:#007F11"><b>',$strInfo,'</b></p>';
echo '</div>
';

if ( file_exists(Translate($oVIP->selfurl.'.txt')) )
{
  echo '<div style="width:400px; position:absolute; top:15px; left:495px; border:solid 1px #eeeeee;">';
  echo '<div class="hlp_head">',$L['Help'],'</div>';
  echo '<div class="hlp_body"><span id="helparea">';
  include(Translate($oVIP->selfurl.'.txt'));
  echo '</span></div></div>';
}

// animation of the infomessage (errors remains on screen)
if ( isset($strInfo) )
{
echo '
<script type="text/javascript">
<!--
setTimeout(\'document.getElementById("infomessage").style.color="#bbbbbb"\',3000);
setTimeout(\'document.getElementById("infomessage").style.color="#cccccc"\',3300);
setTimeout(\'document.getElementById("infomessage").style.color="#dddddd"\',3600);
setTimeout(\'document.getElementById("infomessage").innerHTML="&nbsp;"\',3900);
-->
</script>
';
}

?>